DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Accordion

The JavaScript Accordion component contains several panels displayed one under another. Users can expand or collapse these panels, which makes this component useful to present information in a limited amount of space.

Bind JavaScript Accordion to Data

You can display JavaScript Accordion items from the items array or a dataSource. If you use the items array, specify the title and text properties.

Configure Item Selection and Collapsibility

Enable the multiple property to allow users to select multiple panels. Use the selectedItems array to store selected items. Toggle the "Multiple enabled" checkbox in the Options demo section to see how it affects the selection.

If you want to allow users to close panels on click, set the collapsible property to true. Check the "Collapsible enabled" checkbox in the Options demo section to enable this feature.

Configure Animation

The animationDuration property allows you to specify the animation duration when users expand/collapse a panel. Use the "Animation duration" slider in the Options demo section to see how it affects the animation.

Customize Item Appearance

Use the itemTemplate and itemTitleTemplate properties to customize the panel appearance. If you use the items array, you can also specify the icon property.

Backend API
$(() => { DevExpress.setTemplateEngine({ compile: (element) => $(element).html(), render: (template, data) => Mustache.render(template, data), }); const tagBox = $('#tagbox').dxTagBox({ dataSource: accordionItems, displayExpr: 'CompanyName', disabled: true, value: [accordionItems[0]], inputAttr: { 'aria-label': 'Company Name' }, onValueChanged(e) { accordion.option('selectedItems', e.value); }, }).dxTagBox('instance'); const accordion = $('#accordion-container').dxAccordion({ dataSource: accordionItems, animationDuration: 300, collapsible: false, multiple: false, selectedItems: [accordionItems[0]], itemTitleTemplate: $('#title'), itemTemplate: $('#customer'), onSelectionChanged(e) { tagBox.option('value', e.component.option('selectedItems')); }, }).dxAccordion('instance'); $('#slider').dxSlider({ min: 0, max: 1000, value: 300, label: { visible: true }, tooltip: { enabled: true, position: 'bottom', }, onValueChanged(e) { accordion.option('animationDuration', e.value); }, }); $('#multiple-enabled').dxCheckBox({ text: 'Multiple enabled', onValueChanged(e) { accordion.option('multiple', e.value); tagBox.option('disabled', !e.value); tagBox.option('value', accordion.option('selectedItems')); }, }); $('#collapsible-enabled').dxCheckBox({ text: 'Collapsible enabled', onValueChanged(e) { accordion.option('collapsible', e.value); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="https://unpkg.com/mustache@2.3.2/mustache.min.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="accordion"> <div id="accordion-container"> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <div id="multiple-enabled"></div> </div> <div class="option"> <div id="collapsible-enabled"></div> </div> <div class="option"> <span>Animation duration</span> <div id="slider"></div> </div> <div class="option"> <span class="caption">Selected Items</span> <div id="tagbox"></div> </div> </div> </div> <script type="text/html" id="title"> <div class="header">{{ CompanyName }}</div> </script> <script type="text/html" id="customer"> <div class="accodion-item"> <div> <p> <b>{{ City }}</b> (<span>{{ State }}</span>) </p> <p> <span>{{ Zipcode }}</span> <span>{{ Address }}</span> </p> </div> <div> <p> Phone: <b>{{ Phone }}</b> </p> <p> Fax: <b>{{ Fax }}</b> </p> <p> Website: <a href="{{ Website }}" target="_blank"> {{ Website }} </a> </p> </div> </div> </script> </div> </body> </html>
#accordion { height: 700px; } #accordion .header { font-size: 20px; } #accordion .header, #accordion p { margin: 0; } #accordion-container { margin-right: 400px; } .dx-theme-material #accordion .dx-accordion-item-title { display: flex; } .dx-theme-material #accordion .header { align-self: center; } .options { padding: 20px; position: absolute; bottom: 0; right: 0; width: 340px; top: 0; background-color: rgba(191, 191, 191, 0.15); } .options > .caption { font-weight: 500; font-size: 18px; } .option { margin-top: 10px; } .option > .caption { margin-top: 10px; display: inline-block; } .option > .dx-tagbox { margin-top: 2px; }
const accordionItems = [{ ID: 1, CompanyName: 'Super Mart of the West', Address: '702 SW 8th Street', City: 'Bentonville', State: 'Arkansas', Zipcode: 72716, Phone: '(800) 555-2797', Fax: '(800) 555-2171', Website: 'http://www.nowebsitesupermart.dx', }, { ID: 2, CompanyName: 'Electronics Depot', Address: '2455 Paces Ferry Road NW', City: 'Atlanta', State: 'Georgia', Zipcode: 30339, Phone: '(800) 595-3232', Fax: '(800) 595-3231', Website: 'http://www.nowebsitedepot.dx', }, { ID: 3, CompanyName: 'K&S Music', Address: '1000 Nicllet Mall', City: 'Minneapolis', State: 'Minnesota', Zipcode: 55403, Phone: '(612) 304-6073', Fax: '(612) 304-6074', Website: 'http://www.nowebsitemusic.dx', }, { ID: 4, CompanyName: "Tom's Club", Address: '999 Lake Drive', City: 'Issaquah', State: 'Washington', Zipcode: 98027, Phone: '(800) 955-2292', Fax: '(800) 955-2293', Website: 'http://www.nowebsitetomsclub.dx', }];

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Accordion

The Accordion component contains several panels displayed one under another. Users can expand or collapse these panels, which makes this component useful to present information in a limited amount of space.

Bind Accordion to Data

You can display Accordion items from the items array or a dataSource. If you use the items array, specify the title and text properties.

Configure Item Selection and Collapsibility

Enable the multiple property to allow users to select multiple panels. Use the selectedItems array to store selected items. Toggle the "Multiple enabled" checkbox in the Options demo section to see how it affects the selection.

If you want to allow users to close panels on click, set the collapsible property to true. Check the "Collapsible enabled" checkbox in the Options demo section to enable this feature.

Configure Animation

The animationDuration property allows you to specify the animation duration when users expand/collapse a panel. Use the "Animation duration" slider in the Options demo section to see how it affects the animation.

Customize Item Appearance

Use the itemTemplate and itemTitleTemplate properties to customize the panel appearance. If you use the items array, you can also specify the icon property.

Backend API
import React, { useCallback, useState } from 'react'; import Accordion, { AccordionTypes } from 'devextreme-react/accordion'; import CheckBox, { CheckBoxTypes } from 'devextreme-react/check-box'; import TagBox, { TagBoxTypes } from 'devextreme-react/tag-box'; import Slider, { Tooltip, Label, SliderTypes } from 'devextreme-react/slider'; import service from './data.ts'; import CustomTitle from './CustomTitle.tsx'; import CustomItem from './CustomItem.tsx'; const companyLabel = { 'aria-label': 'Company' }; const companies = service.getCompanies(); const App = () => { const [selectedItems, setSelectedItems] = useState([companies[0]]); const [multiple, setMultiple] = useState(false); const [collapsible, setCollapsible] = useState(false); const [animationDuration, setAnimationDuration] = useState(300); const selectionChanged = useCallback((e: AccordionTypes.SelectionChangedEvent) => { let newItems = [...selectedItems]; e.removedItems.forEach((item) => { const index = newItems.indexOf(item); if (index >= 0) { newItems.splice(index, 1); } }); if (e.addedItems.length) { newItems = [...newItems, ...e.addedItems]; } setSelectedItems(newItems); }, [selectedItems, setSelectedItems]); const selectedItemsChanged = useCallback((e: TagBoxTypes.ValueChangedEvent) => { setSelectedItems(e.value); }, [setSelectedItems]); const multipleChanged = useCallback((e: CheckBoxTypes.ValueChangedEvent) => { setMultiple(e.value); }, [setMultiple]); const collapsibleChanged = useCallback((e: CheckBoxTypes.ValueChangedEvent) => { setCollapsible(e.value); }, [setCollapsible]); const animationDurationChanged = useCallback((e: SliderTypes.ValueChangedEvent) => { setAnimationDuration(e.value); }, [setAnimationDuration]); return ( <div id="accordion"> <Accordion dataSource={companies} collapsible={collapsible} multiple={multiple} animationDuration={animationDuration} selectedItems={selectedItems} onSelectionChanged={selectionChanged} itemTitleRender={CustomTitle} itemRender={CustomItem} id="accordion-container" /> <div className="options"> <div className="caption">Options</div> <div className="option"> <CheckBox text="Multiple enabled" value={multiple} onValueChanged={multipleChanged} /> </div> <div className="option"> <CheckBox text="Collapsible enabled" value={collapsible} onValueChanged={collapsibleChanged} /> </div> <div className="option"> <span>Animation duration</span> <Slider min={0} max={1000} value={animationDuration} onValueChanged={animationDurationChanged} > <Tooltip enabled={true} position="bottom" /> <Label visible={true} /> </Slider> </div> <div className="option"> <span className="caption">Selected Items</span> <TagBox dataSource={companies} displayExpr="CompanyName" value={selectedItems} inputAttr={companyLabel} onValueChanged={selectedItemsChanged} disabled={!multiple} /> </div> </div> </div> ); }; export default App;
import React, { useCallback, useState } from 'react'; import Accordion from 'devextreme-react/accordion'; import CheckBox from 'devextreme-react/check-box'; import TagBox from 'devextreme-react/tag-box'; import Slider, { Tooltip, Label } from 'devextreme-react/slider'; import service from './data.js'; import CustomTitle from './CustomTitle.js'; import CustomItem from './CustomItem.js'; const companyLabel = { 'aria-label': 'Company' }; const companies = service.getCompanies(); const App = () => { const [selectedItems, setSelectedItems] = useState([companies[0]]); const [multiple, setMultiple] = useState(false); const [collapsible, setCollapsible] = useState(false); const [animationDuration, setAnimationDuration] = useState(300); const selectionChanged = useCallback( (e) => { let newItems = [...selectedItems]; e.removedItems.forEach((item) => { const index = newItems.indexOf(item); if (index >= 0) { newItems.splice(index, 1); } }); if (e.addedItems.length) { newItems = [...newItems, ...e.addedItems]; } setSelectedItems(newItems); }, [selectedItems, setSelectedItems], ); const selectedItemsChanged = useCallback( (e) => { setSelectedItems(e.value); }, [setSelectedItems], ); const multipleChanged = useCallback( (e) => { setMultiple(e.value); }, [setMultiple], ); const collapsibleChanged = useCallback( (e) => { setCollapsible(e.value); }, [setCollapsible], ); const animationDurationChanged = useCallback( (e) => { setAnimationDuration(e.value); }, [setAnimationDuration], ); return ( <div id="accordion"> <Accordion dataSource={companies} collapsible={collapsible} multiple={multiple} animationDuration={animationDuration} selectedItems={selectedItems} onSelectionChanged={selectionChanged} itemTitleRender={CustomTitle} itemRender={CustomItem} id="accordion-container" /> <div className="options"> <div className="caption">Options</div> <div className="option"> <CheckBox text="Multiple enabled" value={multiple} onValueChanged={multipleChanged} /> </div> <div className="option"> <CheckBox text="Collapsible enabled" value={collapsible} onValueChanged={collapsibleChanged} /> </div> <div className="option"> <span>Animation duration</span> <Slider min={0} max={1000} value={animationDuration} onValueChanged={animationDurationChanged} > <Tooltip enabled={true} position="bottom" /> <Label visible={true} /> </Slider> </div> <div className="option"> <span className="caption">Selected Items</span> <TagBox dataSource={companies} displayExpr="CompanyName" value={selectedItems} inputAttr={companyLabel} onValueChanged={selectedItemsChanged} disabled={!multiple} /> </div> </div> </div> ); }; export default App;
import React from 'react'; export default function CustomItem(data) { return ( <div> <div> <p> <b>{data.City} </b> (<span>{data.State}</span>) </p> <p> <span>{data.Zipcode} </span> <span>{data.Address}</span> </p> </div> <div> <p> Phone: <b>{data.Phone}</b> </p> <p> Fax: <b>{data.Fax}</b> </p> <p> Website: <a href={data.Website} target="_blank"> {data.Website} </a> </p> </div> </div> ); }
import React from 'react'; export default function CustomTitle(data) { return ( <div className='header'>{data.CompanyName}</div> ); }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
const companies = [{ ID: 1, CompanyName: 'Super Mart of the West', Address: '702 SW 8th Street', City: 'Bentonville', State: 'Arkansas', Zipcode: 72716, Phone: '(800) 555-2797', Fax: '(800) 555-2171', Website: 'http://www.nowebsitesupermart.dx', }, { ID: 2, CompanyName: 'Electronics Depot', Address: '2455 Paces Ferry Road NW', City: 'Atlanta', State: 'Georgia', Zipcode: 30339, Phone: '(800) 595-3232', Fax: '(800) 595-3231', Website: 'http://www.nowebsitedepot.dx', }, { ID: 3, CompanyName: 'K&S Music', Address: '1000 Nicllet Mall', City: 'Minneapolis', State: 'Minnesota', Zipcode: 55403, Phone: '(612) 304-6073', Fax: '(612) 304-6074', Website: 'http://www.nowebsitemusic.dx', }, { ID: 4, CompanyName: "Tom's Club", Address: '999 Lake Drive', City: 'Issaquah', State: 'Washington', Zipcode: 98027, Phone: '(800) 955-2292', Fax: '(800) 955-2293', Website: 'http://www.nowebsitetomsclub.dx', }]; export default { getCompanies() { return companies; }, };
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, defaultExtension: 'js', map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types@15.8.1/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.6/cjs', 'devextreme-react': 'npm:devextreme-react@23.2.6/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.54/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: '', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config);
import React from 'react'; export default function CustomItem(data) { return ( <div> <div> <p> <b>{data.City} </b>(<span>{data.State}</span>) </p> <p> <span>{data.Zipcode} </span> <span>{data.Address}</span> </p> </div> <div> <p> Phone: <b>{data.Phone}</b> </p> <p> Fax: <b>{data.Fax}</b> </p> <p> Website:{' '} <a href={data.Website} target="_blank" > {data.Website} </a> </p> </div> </div> ); }
import React from 'react'; export default function CustomTitle(data) { return <div className="header">{data.CompanyName}</div>; }
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
const companies = [ { ID: 1, CompanyName: 'Super Mart of the West', Address: '702 SW 8th Street', City: 'Bentonville', State: 'Arkansas', Zipcode: 72716, Phone: '(800) 555-2797', Fax: '(800) 555-2171', Website: 'http://www.nowebsitesupermart.dx', }, { ID: 2, CompanyName: 'Electronics Depot', Address: '2455 Paces Ferry Road NW', City: 'Atlanta', State: 'Georgia', Zipcode: 30339, Phone: '(800) 595-3232', Fax: '(800) 595-3231', Website: 'http://www.nowebsitedepot.dx', }, { ID: 3, CompanyName: 'K&S Music', Address: '1000 Nicllet Mall', City: 'Minneapolis', State: 'Minnesota', Zipcode: 55403, Phone: '(612) 304-6073', Fax: '(612) 304-6074', Website: 'http://www.nowebsitemusic.dx', }, { ID: 4, CompanyName: "Tom's Club", Address: '999 Lake Drive', City: 'Issaquah', State: 'Washington', Zipcode: 98027, Phone: '(800) 955-2292', Fax: '(800) 955-2293', Website: 'http://www.nowebsitetomsclub.dx', }, ]; export default { getCompanies() { return companies; }, };
<!DOCTYPE html> <html> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#accordion { height: 700px; } #accordion .header { font-size: 20px; } #accordion .header, #accordion p { margin: 0; } #accordion-container { margin-right: 400px; } .dx-theme-material #accordion .dx-accordion-item-title { display: flex; } .dx-theme-material #accordion .header { align-self: center; } .options { padding: 20px; position: absolute; bottom: 0; right: 0; width: 340px; top: 0; background-color: rgba(191, 191, 191, 0.15); } .options > .caption { font-weight: 500; font-size: 18px; } .option { margin-top: 10px; } .option > .caption { margin-top: 10px; display: inline-block; } .option > .dx-tagbox { margin-top: 2px; }

DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Accordion

The Accordion component contains several panels displayed one under another. Users can expand or collapse these panels, which makes this component useful to present information in a limited amount of space.

Bind Accordion to Data

You can display Accordion items from the items array or a dataSource. If you use the items array, specify the title and text properties.

Configure Item Selection and Collapsibility

Enable the multiple property to allow users to select multiple panels. Use the selectedItems array to store selected items. Toggle the "Multiple enabled" checkbox in the Options demo section to see how it affects the selection.

If you want to allow users to close panels on click, set the collapsible property to true. Check the "Collapsible enabled" checkbox in the Options demo section to enable this feature.

Configure Animation

The animationDuration property allows you to specify the animation duration when users expand/collapse a panel. Use the "Animation duration" slider in the Options demo section to see how it affects the animation.

Customize Item Appearance

Use the itemTemplate and itemTitleTemplate properties to customize the panel appearance. If you use the items array, you can also specify the icon property.

Backend API
<div id="accordion"> <dx-accordion #accordion [dataSource]="companies" [collapsible]="false" [multiple]="false" [animationDuration]="300" [selectedItems]="[companies[0]]" id="accordion-container" > <div *dxTemplate="let company of 'title'"> <div class="header">{{ company.CompanyName }}</div> </div> <div *dxTemplate="let company of 'item'"> <div> <p> <b>{{ company.City }}</b> (<span>{{ company.State }}</span >) </p> <p> <span>{{ company.Zipcode }}</span> <span>{{ company.Address }}</span> </p> </div> <div> <p> Phone: <b>{{ company.Phone }}</b> </p> <p> Fax: <b>{{ company.Fax }}</b> </p> <p> Website: <a href="{{ company.Website }}" target="_blank"> {{ company.Website }} </a> </p> </div> </div> </dx-accordion> <div class="options"> <div class="caption">Options</div> <div class="option"> <dx-check-box text="Multiple enabled" [(value)]="accordion.multiple" ></dx-check-box> </div> <div class="option"> <dx-check-box text="Collapsible enabled" [(value)]="accordion.collapsible" ></dx-check-box> </div> <div class="option"> <span>Animation duration</span> <dx-slider [min]="0" [max]="1000" [(value)]="accordion.animationDuration"> <dxo-tooltip [enabled]="true" position="bottom"></dxo-tooltip> <dxo-label [visible]="true"></dxo-label> </dx-slider> </div> <div class="option"> <span class="caption">Selected Items</span> <dx-tag-box [dataSource]="companies" displayExpr="CompanyName" [(value)]="accordion.selectedItems" [disabled]="!accordion.multiple" [inputAttr]="{ 'aria-label': 'Company' }" ></dx-tag-box> </div> </div> </div>
import { NgModule, Component, enableProdMode } from '@angular/core'; import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { DxAccordionModule, DxCheckBoxModule, DxSliderModule, DxTagBoxModule, DxTemplateModule, } from 'devextreme-angular'; import { Company, Service } from './app.service'; if (!/localhost/.test(document.location.host)) { enableProdMode(); } declare var __moduleName: string; @Component({ selector: 'demo-app', templateUrl: 'app.component.html', styleUrls: ['app.component.css'], moduleId: __moduleName, providers: [Service], preserveWhitespaces: true, }) export class AppComponent { companies: Company[]; constructor(service: Service) { this.companies = service.getCompanies(); } } @NgModule({ imports: [ BrowserModule, BrowserTransferStateModule, DxAccordionModule, DxCheckBoxModule, DxSliderModule, DxTagBoxModule, DxTemplateModule, ], declarations: [AppComponent], bootstrap: [AppComponent], }) export class AppModule { } platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #accordion { height: 700px; } ::ng-deep #accordion .header { font-size: 20px; } ::ng-deep #accordion .header, ::ng-deep #accordion p { margin: 0; } ::ng-deep #accordion-container { margin-right: 400px; } ::ng-deep .dx-theme-material #accordion .dx-accordion-item-title { display: flex; } ::ng-deep .dx-theme-material #accordion .header { align-self: center; } ::ng-deep .options { padding: 20px; position: absolute; bottom: 0; right: 0; width: 340px; top: 0; background-color: rgba(191, 191, 191, 0.15); } ::ng-deep .options > .caption { font-weight: 500; font-size: 18px; } ::ng-deep .option { margin-top: 10px; } ::ng-deep .option > .caption { margin-top: 10px; display: inline-block; } ::ng-deep .option > .dx-tagbox { margin-top: 2px; }
import { Injectable } from '@angular/core'; export class Company { ID: number; CompanyName: string; Address: string; City: string; State: string; Zipcode: number; Phone: string; Fax: string; Website: string; } const companies: Company[] = [{ ID: 1, CompanyName: 'Super Mart of the West', Address: '702 SW 8th Street', City: 'Bentonville', State: 'Arkansas', Zipcode: 72716, Phone: '(800) 555-2797', Fax: '(800) 555-2171', Website: 'http://www.nowebsitesupermart.dx', }, { ID: 2, CompanyName: 'Electronics Depot', Address: '2455 Paces Ferry Road NW', City: 'Atlanta', State: 'Georgia', Zipcode: 30339, Phone: '(800) 595-3232', Fax: '(800) 595-3231', Website: 'http://www.nowebsitedepot.dx', }, { ID: 3, CompanyName: 'K&S Music', Address: '1000 Nicllet Mall', City: 'Minneapolis', State: 'Minnesota', Zipcode: 55403, Phone: '(612) 304-6073', Fax: '(612) 304-6074', Website: 'http://www.nowebsitemusic.dx', }, { ID: 4, CompanyName: "Tom's Club", Address: '999 Lake Drive', City: 'Issaquah', State: 'Washington', Zipcode: 98027, Phone: '(800) 955-2292', Fax: '(800) 955-2293', Website: 'http://www.nowebsitetomsclub.dx', }]; @Injectable() export class Service { getCompanies(): Company[] { return companies; } }
// In real applications, you should not transpile code in the browser. // You can see how to create your own application with Angular and DevExtreme here: // https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/ window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, }, meta: { 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'npm:': 'https://unpkg.com/', }, map: { 'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', '@angular/core': 'npm:@angular/core@12.2.17', '@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17', '@angular/forms': 'npm:@angular/forms@12.2.17', '@angular/common': 'npm:@angular/common@12.2.17', '@angular/compiler': 'npm:@angular/compiler@12.2.17', 'tslib': 'npm:tslib@2.6.2/tslib.js', 'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js', 'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@23.2.6/cjs', 'devextreme/bundles/dx.all': 'npm:devextreme@23.2.6/bundles/dx.all.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.6.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.5', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.54', 'devextreme-angular': 'npm:devextreme-angular@23.2.6', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.4/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js', }, packages: { 'app': { main: './app.component.ts', defaultExtension: 'ts', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, 'rxjs': { defaultExtension: 'js', }, 'rxjs/operators': { defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.12/inferno/package.json', 'npm:@angular/*/package.json', 'npm:@angular/common@12.2.17/*/package.json', 'npm:rxjs@7.5.3/package.json', 'npm:rxjs@7.5.3/operators/package.json', 'npm:devextreme-angular@23.2.6/*/package.json', 'npm:devextreme-angular@23.2.6/ui/*/package.json', 'npm:devextreme-angular@23.2.6/package.json', 'npm:devexpress-diagram@2.2.5/package.json', 'npm:devexpress-gantt@4.1.54/package.json', ], }; System.config(window.config);
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script> <script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script src="config.js"></script> <script> System.import("app").catch(console.error.bind(console)); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <demo-app>Loading...</demo-app> </div> </body> </html>